import 'dart:html';
import 'dart:math';
import 'package:pixi/pixi.dart';


class IteractivityExample
{
	//var renderer	= new CanvasRenderer(width: 400, height: 300, interactive: true);
	var renderer			= new WebGLRenderer(width: 620, height: 400, interactive: true);
	var stage				= new Stage(new Colour.fromHtml('#000'));
	var background			= new Sprite.fromImage("button_test_BG.jpg");
	List<Sprite> buttons	= new List<Sprite>();
	//var bunny		= new Sprite.fromImage("bunny.png");


	IteractivityExample()
	{
		document.body.append(this.renderer.view);

		this.stage.children.add(background);

		var positions = [
			new Point(175, 75),
			new Point(600-145, 75),
			new Point(600/2 - 20, 400/2 + 10),
	   		new Point(175, 400-75),
		 	new Point(600-115, 400-95)
		];

		var textures = {
			"button"	: new Texture.fromImage("button.png"),
			"down"		: new Texture.fromImage("buttonDown.png"),
			"over"		: new Texture.fromImage("buttonOver.png")
		};

		for (int i=0; i<5; i++)
		{
			var button			= new Sprite(textures["button"]);
			//button.buttonMode	= true;
			button.anchor		= new Point(0.5, 0.5);
			button.position		= positions[i];

			//button.onMouseDown.listen(onData)


			this.stage.children.add(button);
			this.buttons.add(button);
		}

		this.buttons[0].scale		= new Point(1.2, 1.0);
		this.buttons[1].scale		= new Point(1.0, 1.2);
		this.buttons[2].rotation	= PI / 10;
		this.buttons[3].scale		= new Point(0.8, 0.8);
		this.buttons[4].scale		= new Point(0.8, 1.2);
		this.buttons[4].rotation	= PI;


		window.requestAnimationFrame(this._animate);
	}


	void _animate(var num)
	{
		window.requestAnimationFrame(this._animate);
		this.renderer.render(this.stage);
	}
}


void main()
{
	new IteractivityExample();
}



/*


	for (var i=0; i < 5; i++)
	{
		var button = new PIXI.Sprite(textureButton);
		button.buttonMode = true;

		button.anchor.x = 0.5;
		button.anchor.y = 0.5;

		button.position.x = buttonPositions[i*2];
		button.position.y = buttonPositions[i*2 + 1];

		// make the button interactive..
		button.interactive = true;

		// set the mousedown and touchstart callback..
		button.mousedown = button.touchstart = function(data){

			this.isdown = true;
			this.setTexture(textureButtonDown);
			this.alpha = 1;
		}

		// set the mouseup and touchend callback..
		button.mouseup = button.touchend = button.mouseupoutside = button.touchendoutside = function(data){
			this.isdown = false;

			if(this.isOver)
			{
				this.setTexture(textureButtonOver);
			}
			else
			{
				this.setTexture(textureButton);
			}
		}

		// set the mouseover callback..
		button.mouseover = function(data){

			this.isOver = true;

			if(this.isdown)return

			this.setTexture(textureButtonOver)
		}

		// set the mouseout callback..
		button.mouseout = function(data){

			this.isOver = false;
			if(this.isdown)return
			this.setTexture(textureButton)
		}

		button.click = function(data){
			// click!
			console.log("CLICK!");
		//	alert("CLICK!")
		}

		button.tap = function(data){
			// click!
			console.log("TAP!!");
			//this.alpha = 0.5;
		}

		// add it to the stage
		stage.addChild(button);

		// add button to array
		buttons.push(button);
	};

	// set some silly values..

	buttons[0].scale.x = 1.2;

	buttons[1].scale.y = 1.2;

	buttons[2].rotation = Math.PI/10;

	buttons[3].scale.x = 0.8;
	buttons[3].scale.y = 0.8;

	buttons[4].scale.x = 0.8;
	buttons[4].scale.y = 1.2;
	buttons[4].rotation = Math.PI;
	// var button1 =
	function animate() {

	    requestAnimFrame( animate );
	    // render the stage

	    // do a test..

	    renderer.render(stage);
	}

	// add a logo!
	var pixiLogo = PIXI.Sprite.fromImage("pixi.png");
	stage.addChild(pixiLogo);

	pixiLogo.position.x = 620 - 56;
	pixiLogo.position.y = 400- 32;

	pixiLogo.setInteractive(true);

	pixiLogo.click = pixiLogo.tap = function(){

		var win=window.open("https://github.com/GoodBoyDigital/pixi.js", '_blank');

	}
	</script>*/