part of pixi;


class InteractionEvent
{
	final num x;
	final num y;

	InteractionEvent(this.x, this.y);
}


class _InteractiveController
{
	//StreamController<InteractionEvent> click		= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> mouseDown	= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> mouseUp		= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> mouseOver	= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> mouseOut		= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> tap			= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> touchStart	= new StreamController<InteractionEvent>.broadcast();
	//StreamController<InteractionEvent> touchEnd		= new StreamController<InteractionEvent>.broadcast();
	Map<String, StreamController<InteractionEvent>> controllers = {};

	StreamController<InteractionEvent> operator [] (String type)
	{
		return this.controllers.putIfAbsent(type, () => new StreamController<InteractionEvent>.broadcast());
	}

	bool has(String type)		=> this.controllers.containsKey(type);
	bool listening(String type)	=> this.controllers.containsKey(type) && this.controllers[type].hasListener;
	bool get enabled			=> this.controllers.isNotEmpty;
}


// A DisplayObject will become interactive automatically if you access
// any of the event streams.
class _Interactive
{
	//_InteractiveController __controller			= null;
	//_InteractiveController get _controller		=> this.__controller == null ? (this.__controller = new _InteractiveController()) : this.__controller;
	_InteractiveController _controller			= new _InteractiveController();
	Stream<InteractionEvent> get onClick		=> this._controller["click"].stream;
	Stream<InteractionEvent> get onMouseDown	=> this._controller["mouseDown"].stream;
	Stream<InteractionEvent> get onMouseUp		=> this._controller["mouseUp"].stream;
	Stream<InteractionEvent> get onMouseOver	=> this._controller["mouseOver"].stream;
	Stream<InteractionEvent> get onMouseOut		=> this._controller["mouseOut"].stream;
	Stream<InteractionEvent> get onTap			=> this._controller["tap"].stream;
	Stream<InteractionEvent> get onTouchStart	=> this._controller["touchStart"].stream;
	Stream<InteractionEvent> get onTouchEnd		=> this._controller["touchEnd"].stream;
	bool get interactive						=> this._controller.enabled;

	bool _over = false;
	bool _down = false;
	//var _hitArea	= null;

	bool _hit(double x, double y)
	{
		return false;
	}
}


/*PIXI.InteractionManager.prototype.hitTest = function(item, interactionData)
{
    var global = interactionData.global;

    if( !item.worldVisible )return false;

    // temp fix for if the element is in a non visible

    var isSprite = (item instanceof PIXI.Sprite),
        worldTransform = item.worldTransform,
        a00 = worldTransform[0], a01 = worldTransform[1], a02 = worldTransform[2],
        a10 = worldTransform[3], a11 = worldTransform[4], a12 = worldTransform[5],
        id = 1 / (a00 * a11 + a01 * -a10),
        x = a11 * id * global.x + -a01 * id * global.y + (a12 * a01 - a02 * a11) * id,
        y = a00 * id * global.y + -a10 * id * global.x + (-a12 * a00 + a02 * a10) * id;

    interactionData.target = item;

    //a sprite or display object with a hit area defined
    if(item.hitArea && item.hitArea.contains) {
        if(item.hitArea.contains(x, y)) {
            //if(isSprite)
            interactionData.target = item;

            return true;
        }

        return false;
    }
    // a sprite with no hitarea defined
    else if(isSprite)
    {
        var width = item.texture.frame.width,
            height = item.texture.frame.height,
            x1 = -width * item.anchor.x,
            y1;

        if(x > x1 && x < x1 + width)
        {
            y1 = -height * item.anchor.y;

            if(y > y1 && y < y1 + height)
            {
                // set the target property if a hit is true!
                interactionData.target = item;
                return true;
            }
        }
    }

    var length = item.children.length;

    for (var i = 0; i < length; i++)
    {
        var tempItem = item.children[i];
        var hit = this.hitTest(tempItem, interactionData);
        if(hit)
        {
            // hmm.. TODO SET CORRECT TARGET?
            interactionData.target = item;
            return true;
        }
    }

    return false;
};*/
